﻿using Microsoft.SharePoint.WebPartPages;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace YammerWebPart1.VisualWebPart1.CustomTools
{
    public class OptionsToolpart : ToolPart
    {
        public DropDownList discussionsOption { get; set; }

        public OptionsToolpart()
        {

        }

        protected override void CreateChildControls()
        {
            this.discussionsOption = new DropDownList();
            this.discussionsOption.ID = "discussionsOption";
            this.discussionsOption.Text = "textProp";

            var wp = this.ParentToolPane.SelectedWebPart as VisualWebPart1;

            foreach (YammerWebPart1.VisualWebPart1.VisualWebPart1.Discussion d in wp.Discussions)
                if (d.Equals(wp.ChosenDiscussion))
                    this.discussionsOption.Items.Add(new ListItem() { Value = d.Name, Text = d.Displayed, Selected = true });
                else
                    this.discussionsOption.Items.Add(new ListItem() { Value = d.Name, Text = d.Displayed, Selected = false });

            this.discussionsOption.Enabled = true;
            this.discussionsOption.CssClass = "none";
            this.discussionsOption.AutoPostBack = true;
            this.discussionsOption.SelectedIndexChanged += discussionsOption_SelectedIndexChanged;

            this.Controls.Add(this.discussionsOption);
        }

        void discussionsOption_SelectedIndexChanged(object sender, EventArgs e)
        {
            var wp = this.ParentToolPane.SelectedWebPart as VisualWebPart1;

            int i = this.discussionsOption.SelectedIndex;
            wp.ChosenDiscussion = wp.Discussions[i];
        }

        public override void ApplyChanges()
        {
            this.SyncChanges();
        }

        public override void SyncChanges()
        { 
        }

        public override void CancelChanges()
        {

        }

        protected override void RenderToolPart(HtmlTextWriter output)
        {
            base.RenderToolPart(output);
        }
    }
}
