(function (window, initializeCore, undefined) {

    var YammerCore = function (s) {
        return new YammerCore.fn.Init(s);
    },
        handlers, classObjects, uniqueId, entities, rlist, rspace,
        Initialize = function () {

            handlers = {};
            classObjects = {};
            uniqueId = 0;
            entities = {};

            rlist = /\s*,\s*/;
            rspace = /\s+/;
        };

    Initialize();

    YammerCore.fn = YammerCore.prototype = {
        Init: function (s) {

            if (typeof s === "string") {

                var element = 0,
                    e,
                    current,
                    and = false,
                    or = false,
                    comps,
                    score,
                    l,
                    del;

                if (s.indexOf(',') !== -1) {

                    or = true;
                    del = rlist;

                } else if (s.indexOf(' ') !== -1) {
                    and = true;
                    del = rspace;
                }


                for (e in entities) {


                    if (!entities.hasOwnProperty(e))
                        continue;


                    current = entities[e];

                    if (and || or) {

                        comps = s.split(del);
                        i = 0;
                        l = comps.length;
                        score = 0;

                        for (; i < l; i++)
                            if (current.__c[comps[i]]) score++;

                        if (and && score === l || or && score > 0) this[element++] = +e;

                    } else if (current.__c[s]) this[element++] = +e;

                    if (current.__c[s])
                        this[element++] = +e;
                }


                if (element > 0 && !and && !or) this.extend(classObjects[s]);

                if (comps && and) for (i = 0; i < l; i++) this.extend(classObjects[comps[i]]);

                this.length = element;

                if (element === 1) {
                    return entities[this[element - 1]];
                }


            } else {

                if (!s) {
                    s = 0;
                    if (!(s in entities)) entities[s] = this;
                }

                if (!(s in entities)) {
                    this.length = 0;
                    return this;
                }

                this[0] = s;
                this.length = 1;


                if (!this.__c) this.__c = {};


                if (!entities[s]) entities[s] = this;

                return entities[s];
            }


            return this;
        },

        Each: function (o) {

            var i = 0, l = this.length;
            for (; i < l; i++) {

                if (!entities[this[i]]) continue;
                o.call(entities[this[i]], i);
            }
            return this;

        },

        Set: function (key, value) {


            if (arguments.length === 1) {

                if (typeof key === "string") {
                    return this[key];
                }

                this.extend(key);
                this.FireEvent("Change", key);
                return this;
            }

            this[key] = value;

            var change = {};
            change[key] = value;
            this.FireEvent("Change", change);

            return this;

        },

        BindEvent: function (event, callback) {

            if (this.length === 1) {
                if (!handlers[event]) handlers[event] = {};
                var h = handlers[event];

                if (!h[this[0]]) h[this[0]] = [];
                h[this[0]].push(callback);
                return this;
            }

            this.Each(function () {

                if (!handlers[event]) handlers[event] = {};
                var h = handlers[event];

                if (!h[this[0]]) h[this[0]] = [];
                h[this[0]].push(callback);
            });
            return this;
        },

        UnBindEvent: function (event, callback) {

            this.Each(function () {
                var hdl = handlers[event], i = 0, l, current;

                if (hdl && hdl[this[0]]) l = hdl[this[0]].length;
                else return this;

                if (!callback) {
                    delete hdl[this[0]];
                    return this;
                }

                for (; i < l; i++) {
                    current = hdl[this[0]];
                    if (current[i] == callback) {
                        current.splice(i, 1);
                        i--;
                    }
                }

                callback();
            });
        },

        FireEvent: function (event, data) {

            if (this.length === 1) {

                if (handlers[event] && handlers[event][this[0]]) {
                    var callbacks = handlers[event][this[0]], i = 0, l = callbacks.length;
                    for (; i < l; i++) {
                        callbacks[i].call(this, data);
                    }
                }
                return this;
            }

            this.Each(function () {

                var callbacks = handlers[event][this[0]], i;

                for (i = 0; i < callbacks.length; i++) {
                    if (typeof callbacks[i] === "undefined") {
                        callbacks.splice(i, 1);
                        i--;
                    } else {
                        callbacks[i].call(this, data);
                    }
                }

                if (handlers[event] && handlers[event][this[0]]) {
                    //var callbacks = handlers[event][this[0]], i = 0, l = callbacks.length;
                    var callbacks = handlers[event][this[0]], i;

                    //for (; i < l; i++) {
                    //    callbacks[i].call(this, data);
                    //}

                    for (i = 0; i < callbacks.length; i++) {
                        if (typeof callbacks[i] === "undefined") {
                            callbacks.splice(i, 1);
                            i--;
                        } else {
                            callbacks[i].call(this, data);
                        }
                    }

                }
            });
            return this;
        },

        Requires: function (list) {
            var comps = list.split(rlist),
                i = 0, l = comps.length, comp;

            for (; i < l; ++i) {
                comp = comps[i];
                if (!this.Has(comp)) this.AddClassObject(comp);
            }

            return this;
        },

        Has: function (id) {
            return !!this.__c[id];
        },

        AddClassObject: function (id) {

            var uninit = [], c = 0, ul, i = 0, l, objs, obj;


            ul = uninit.length;

            if (arguments.length > 1) {

                l = arguments.length;

                for (; i < l; i++) {
                    uninit.push(arguments[i]);
                }


            } else if (id.indexOf(',') !== -1) {

                objs = id.split(rlist);
                l = objs.length;

                for (; i < l; i++) {
                    uninit.push(objs[i]);
                }

            } else {
                uninit.push(id);
            }

            ul = uninit.length;

            for (; c < ul; c++) {
                if (this.__c[uninit[c]] == true) continue;

                this.__c[uninit[c]] = true;

                obj = classObjects[uninit[c]];
                this.extend(obj);

                if (obj && "Init" in obj) {
                    obj.Init.call(this);
                } else if (obj && "init" in obj) {
                    obj.init.call(this);
                }
            }

            this.EntityType = uninit[0];

            this.FireEvent("NewComponent", uninit);

            return this;
        },

        SetName: function (name) {

            var entityName = String(name);

            this._entityName = entityName;

            this.FireEvent("NewEntityName", entityName);

            return this;
        },

        Delete: function () {

            this.Each(function () {
                this.FireEvent("Remove");
                for (var e in handlers) {
                    this.UnBindEvent(e);
                }
                delete entities[this[0]];
            });
        }
    };

    YammerCore.fn.Init.prototype = YammerCore.fn;

    YammerCore.extend = YammerCore.fn.extend = function (obj) {

        var target = this, key;

        if (!obj) return target;

        for (key in obj) {

            if (target === obj[key]) {

                continue;
            }

            target[key] = obj[key];
        }
        return target;
    };

    YammerCore.extend({
        Init: function () {
            return this;
        },

        ClassObject: function (name, co) {


            classObjects[name] = co;

        },

        BindEvent: function (event, callback) {

            if (!handlers[event]) {
                handlers[event] = {};
            }

            var handler = handlers[event];

            if (!handler.global) handler.global = [];
            return handler.global.push(callback) - 1;
        },

        FireEvent: function (event, data) {

            var handler = handlers[event], h, i, l;

            for (h in handler) {
                if (!handler.hasOwnProperty(h)) continue;

                for (i = 0, l = handler[h].length; i < l; i++) {
                    if (handler[h] && handler[h][i]) {

                        if (entities[h]) {
                            handler[h][i].call(YammerCore(+h), data);
                        } else {
                            handler[h][i].call(YammerCore, data);
                        }
                    }
                }
            }
        },

        UnBindEvent: function (event, callback) {


            var handler = handlers[event], h, i, l;

            for (h in handler) {

                if (!handler.hasOwnProperty(h)) continue;


                if (typeof callback === "number") {
                    delete handler[h][callback];
                    return true;
                }
                for (i = 0, l = handler[h].length; i < l; i++) {

                    if (typeof handler[h][i] === "function") {

                        delete handler[h][i];
                        return true;
                    }
                }
            }

            return false;


        },

        Entity: function () {

            var entityId = Guid(), core;

            entities[entityId] = null;
            entities[entityId] = core = YammerCore(entityId);


            if (arguments.length > 0) {
                core.AddClassObject.apply(core, arguments);
            }
            core.SetName('Entity #' + entityId);

            //core.AddClassObject("obj");

            YammerCore.FireEvent("NewEntity", { id: entityId });

            return core;

        },

        ClassObjects: function () {

            return classObjects;
        }
    });


    function Guid() {

        var id = uniqueId++;

        if (id in entities)
            return Guid();

        return id;

    }


    initializeCore(YammerCore, window, window.document);

    window.YammerCore = YammerCore;

    if (typeof define === 'function') {
        define('YammerCore', [], function () { return YammerCore; });
    }

})(window, function (YammerCore, window, document) {


    // #.Net Folder
    // @HttpClient
    // 
    YammerCore.extend({

        HttpClient: {

            SignIn: function (val) {

                if (!val) {
                    if (this.IsAuthenticated() == false) {

                        // @TODO
                    }
                } else {

                }

            },

            GetCurrentUser: function (callback) {

                if (!callback) throw "UndefinedCallback";
                YammerCore.HttpClient.GetAuthenticationStatus(function (result) {
                    yam.getLoginStatus(function (resp) {
                        if (resp.authResponse) callback(resp.user);
                        else callback(null);
                    });

                });

            },

            GetAsync: function (uri, callback) {

                YammerCore.HttpClient.GetAuthenticationStatus(function (result) {

                    if (result == true) {
                        yam.request({

                            url: uri,
                            method: "GET",
                            data: {},
                            success: callback,
                            error: function (data) {
                                //console.log("GETASYNC ERROR : ", data);
                            }

                        });
                    } else {
                        // @TODO
                    }
                });

            },

            SignOut: function () {



            },

            GetAuthenticationStatus: function (callback) {
                if (!callback) throw "UndefinedCallback";

                yam.getLoginStatus(function (response) {
                    if (response.authResponse) {
                        callback(true);
                    }
                    else {
                        callback(false);
                    }
                });
            },



            Search: function (query, page, num_per_page) {

                var api = YammerCore.YammerApi;
                var uri = api.BaseUri + api.Version + api.Endpoints.Search + ".json";

                if (query) {

                    uri += "?search=" + query;

                    if (page && !isNaN(page)) uri += "&page=" + page;
                    if (num_per_page && !isNaN(num_per_page)) uri += "&num_per_page=" + num_per_page;

                    this.GetAsync(uri, YammerCore.HtmlWorker.SearchCompleted);


                } else {
                    alert("Query is null");
                }

                return uri;
            }



        }

    });

    YammerCore.extend({

        HtmlWorker: {

            SearchCompleted: function (results) {

                var active = false;

                var tabStatus = function () {
                    if (active == false) {
                        active = true;
                        return 'class="active"';
                    } else {
                        return "";
                    }
                };

                var fetchConversations = function (messages, containerElement) {

                    var getReferenceId = function (id) {
                        if (isNaN(id)) throw "ArgumentException : id must be a number.";
                        for (var j = 0; j < messages.references.length; j++) {
                            if (id == messages.references[j].id) return messages.references[j];
                        }
                        return null;
                    };



                    for (var i = 0; i < messages.messages.length; i++) {
                        var currentMessage = messages.messages[i];
                        // - Container
                        //
                        var conversation = document.createElement('li');
                        conversation.innerHTML = messageSearchElement;

                        var content = currentMessage.body.rich.trim() == "" ? currentMessage.body.plain : currentMessage.body.rich;

                        $(conversation).find(".message-content").first().append(content);
                        $(conversation).find(".message-privacy").first().append(currentMessage.privacy);

                        if (currentMessage.attachments.length > 0) {
                            for (var j = 0; j < currentMessage.attachments.length; j++) {
                                if (currentMessage.attachments[j].type == "ymodule") {
                                    $(conversation).find(".message-content").first().append(currentMessage.attachments[j].inline_html);
                                }
                            }
                        }

                        if (currentMessage.direct_to_id && currentMessage.direct_to_id == YammerCore.Profile.Me.User.id) {
                            $(conversation).find(".message-recipient").first().text("to you");
                        }


                        // Get Sender
                        //
                        var sender = getReferenceId(currentMessage.sender_id);

                        if (sender == null) throw "NullReferenceException : message sender is null.";
                        else {
                            $(conversation).find(".message-username").first().append(sender.full_name);
                            $(conversation).find(".message-image").first().children('img').attr("src", sender.mugshot_url);
                        }

                        var dom = YammerCore.Entity("DisposableUIElement, SearchEntity").Set({
                            VisualElement: conversation,
                            DataContext: currentMessage
                        });

                        dom.BindEvent("OnClick", function (data) {
                            var page = window.open(data.dataContext.web_url, '_blank');
                            page.focus();
                        });

                        containerElement.children(".search-results").append(conversation);
                    }

                };
                var fetchPeople = function (people, containerElement) {

                    for (var i = 0; i < people.length; i++) {

                        var user = document.createElement('li');
                        user.innerHTML = peopleSearchElement;

                        $(user).find(".people-username").first().append(people[i].full_name);
                        $(user).find(".people-status").first().append(people[i].job_title);
                        $(user).find(".people-image").first().children('img').attr("src", people[i].mugshot_url);
                        $(user).find(".people-followers").first().append(people[i].stats.followers);
                        $(user).find(".people-joined").first().append(people[i].activated_at);

                        var dom = YammerCore.Entity("DisposableUIElement, SearchEntity").Set({
                            VisualElement: user,
                            DataContext: people[i]
                        });

                        dom.BindEvent("OnClick", function (data) {
                            var page = window.open(data.dataContext.web_url, '_blank');
                            page.focus();
                        });

                        containerElement.children(".search-results").append(user);
                    }
                };
                var fetchPraises = function (praises, containerElement) {

                    for (var i = 0; i < praises.messages.length; i++) {

                    }
                };
                var fetchGroups = function (groups, containerElement) {

                    for (var i = 0; i < groups.length; i++) {
                        var group = document.createElement('li');
                        group.innerHTML = groupsSearchElement;

                        $(group).find(".groups-title").first().append(groups[i].full_name);
                        $(group).find(".groups-status").first().append(groups[i].job_title);
                        $(group).find(".groups-image").first().children('img').attr("src", groups[i].mugshot_url);
                        $(group).find(".groups-members").first().append(groups[i].stats.members);
                        var dom = YammerCore.Entity("DisposableUIElement, SearchEntity").Set({
                            VisualElement: group,
                            DataContext: groups[i]
                        });

                        dom.BindEvent("OnClick", function (data) {
                            var page = window.open(data.dataContext.web_url, '_blank');
                            page.focus();
                        });

                        containerElement.children(".search-results").append(group);
                    }
                };

                // Get page displayer and clean it
                //
                var displayer = $(YammerCore.Config.DOM.Displayer);

                var tabcontrol = '<div class="tab-control" id="tab-with-event" data-effect="fade[slide]" data-role="tab-control"><ul class="tabs"></ul><div class="frames"></div></div>';

                displayer.append(tabcontrol);



                if (results.count.messages > 0) {
                    displayer.children(".tab-control").children(".tabs").append('<li ' + tabStatus() + '><a href="#_tab_page_conversation">Conversations (' + results.count.messages + ')</a></li>');
                    displayer.children(".tab-control").children(".frames").append('<div class="frame" id="_tab_page_conversation"></div>');

                    var container = displayer.find("#_tab_page_conversation").first();
                    container.append('<ul class="search-results"></ul>');
                    fetchConversations(results.messages, container);
                }

                if (results.count.users > 0) {



                    displayer.children(".tab-control").children(".tabs").append('<li  ' + tabStatus() + '><a href="#_tab_page_people">People (' + results.count.users + ')</a></li>');
                    displayer.children(".tab-control").children(".frames").append('<div class="frame" id="_tab_page_people"></div>');

                    var container = displayer.find("#_tab_page_people").first();
                    container.append(peopleSearchHeader);
                    container.append('<ul class="search-results"></ul>');

                    fetchPeople(results.users, container);
                }

                if (results.count.praises > 0) {
                    displayer.children(".tab-control").children(".tabs").append('<li  ' + tabStatus() + '><a href="#_tab_page_praises">Praises (' + results.count.praises + ')</a></li>');
                    displayer.children(".tab-control").children(".frames").append('<div class="frame" id="_tab_page_praises"></div>');

                    var container = displayer.find("#_tab_page_praises").first();
                    container.append('<ul class="search-results"></ul>');

                    fetchPraises(results.messages, container);
                }

                if (results.count.groups > 0) {
                    displayer.children(".tab-control").children(".tabs").append('<li  ' + tabStatus() + '><a href="#_tab_page_groups">Groups (' + results.count.groups + ')</a></li>');
                    displayer.children(".tab-control").children(".frames").append('<div class="frame" id="_tab_page_groups"></div>');

                    var container = displayer.find("#_tab_page_groups").first();
                    container.append(groupsSearchHeader);
                    container.append('<ul class="search-results"></ul>');

                    fetchGroups(results.groups, container);
                }

                $('.tab-control').tabcontrol();
                $('.tab-control').tabcontrol({
                    effect: 'slide'
                });
            }

        }

    });

    // #.Net Folder
    // @YammerApi
    // 
    YammerCore.extend({

        YammerApi: {

            BaseUri: "https://www.yammer.com/api/",

            Version: "v1",

            Endpoints:
            {
                Messages: "/messages",

                Notifications: "/streams/notifications",

                Suggestions: "/v1/suggestions",

                MyFeed: "/messages/my_feed",

                Algo: "/messages/algo",

                Following: "/messages/following",

                Sent: "/messages/sent",

                Private: "/messages/private",

                Received: "/messages/received",

                PendingAttachment: "/pending_attachments",

                Email: "/messages/email",

                Thread: "/threads",

                Likes: "/messages/liked_by/current",

                Topics: "/topics",

                Groups: "/group_memberships",

                Users: "/users",

                CurrentUser: "/users/current",

                Subscription: "/subscriptions",

                UserSubscription: "/subscriptions/to_user",

                ThreadSubscription: "/subscriptions/to_thread",

                TopicSubscription: "/subscriptions/to_topic",

                UserEmail: "/users/by_email",

                AutoComplete: "/autocomplete/ranked",

                Invitation: "/invitations",

                Search: "/search",

                Network: "/networks/current"
            },

            Methods:
            {
                GET: 0,
                POST: 1,
                DELETE: 2,
                PUT: 3
            }

        }

    });

    // #.Config
    //
    // @class Config 
    // @sign public static 
    //
    YammerCore.extend({

        Config: {

            DOM: {
                PageContent: "#yam-content",
                FormSearch: "#yam-form-search",
                Displayer: "#displayer"
            }
        },

        Settings: {

            ResultPerPage: 5
        }

    });

    YammerCore.ClassObject("User", {

        Init: function () {

            this.IsMe = false;
            this.User = null;

        }
    });

    YammerCore.extend({

        Profile: {

            Me: null,

            Init: function () {

                YammerCore.BindEvent("Connected", function (user) {

                    if (YammerCore.Profile.Me != null) {
                        YammerCore.Profile.Me.Delete();
                    }

                    YammerCore.Profile.Me = YammerCore.Entity("User").Set(
                        {
                            IsMe: true,
                            User: user
                        });

                    $("#nav-profile").first('span').text(user.full_name);

                    var img = document.createElement('img');
                    img.src = user.mugshot_url;
                    $("#nav-profile").append(img);

                });

            }

        }

    });

    // #.Core Folder
    // @Initializer
    YammerCore.extend({

        Initializer: {

            LastQuery: "",

            Init: function () {

                //$("#yam-signout").click(function() {
                //    YammerCore.HttpClient.SignOut();
                //});

                YammerCore.Profile.Init();

                YammerCore.HttpClient.GetCurrentUser(function (user) {
                    if (user != null) YammerCore.FireEvent("Connected", user);
                });

                yam.connect.loginButton('#yammer-login', function (resp) {

                    YammerCore.HttpClient.GetAuthenticationStatus(function (result) {

                        if (result == true) {
                            YammerCore.FireEvent("Connected", resp.user);
                        }
                    });

                });

                // Core Events 
                //
                this.InitSubscribers();

                // User Interface listeners
                //
                this.InitListeners();
            },

            InitSubscribers: function () {
                var self = this;
                // Occurs when a new search has been performed
                //
                YammerCore.BindEvent("OnSearchSubmited", function (query) {

                    if (query.trim() == "") return;
                    else self.LastQuery = query;
                    // Get page displayer and clean it
                    //
                    var displayer = $(YammerCore.Config.DOM.Displayer);
                    displayer.empty();

                    YammerCore("SearchEntity").Each(function (e) {
                        this.Delete();
                    });

                    YammerCore.Settings.ResultPerPage = $(".nb-result.active").children('a').text().trim();
                    if (YammerCore.Settings.ResultPerPage && !isNaN(YammerCore.Settings.ResultPerPage)) {
                        YammerCore.HttpClient.Search(query, null, YammerCore.Settings.ResultPerPage);
                    } else {
                        YammerCore.HttpClient.Search(query, null, 5);
                    }



                });

            },

            InitListeners: function () {
                var self = this;
                $(".nb-result").click(function () {
                    $(".nb-result").removeClass("active");
                    this.addClass("active");

                    if (self.LastQuery != "") {
                        YammerCore.FireEvent("OnSearchSubmited", self.LastQuery);
                    }

                });

                $("#yam-input-search").on('keydown', function (e) {
                    if (e.keyCode == 13) {
                        YammerCore.FireEvent("OnSearchSubmited", $(YammerCore.Config.DOM.FormSearch).find("input:first").val());
                        return false;
                    }
                });

                $("#yam-button-search").click(function () {
                    YammerCore.FireEvent("OnSearchSubmited", $(YammerCore.Config.DOM.FormSearch).find("input:first").val());
                    return false;
                });

            }
        }
    });

    // #.UIElement
    // @class UIElement
    //
    // @sign public 
    //
    YammerCore.ClassObject("UIElement", {

        Init: function () {

            var _isVisible = true;
            var _visualElement = null;
            var _dataContext = null;

            var self = this;

            Object.defineProperties(this,
                {
                    "IsVisible": {
                        get: function () { return _isVisible; },
                        set: function (value) {
                            if (!(value instanceof Boolean)) throw "TypeException : Boolean expected";
                            else {
                                _isVisible = value;
                                this.FireEvent("VisibilityChanged");
                            }
                        }
                    },
                    "DataContext": {
                        get: function () { return _dataContext; },
                        set: function (value) {
                            _dataContext = value;
                        }
                    },
                    "VisualElement": {
                        get: function () {
                            return _visualElement;
                        },
                        set: function (value) {
                            //if (!(value instanceof HtmlElement)) throw "TypeException : Boolean expected";
                            _visualElement = value;
                            var self = this;
                            $(_visualElement).click(function (evt) { self.FireEvent("OnClick", { event: evt, dataContext: self.DataContext }); });

                        }
                    }

                });

        },

        InitSubscribers: function () {
            var self = this;

            this.BindEvent("VisibilityChanged", function (value) {
                if (!self.VisualElement || self.VisualElement == null) throw "NullReferenceException : VisualElement is not defined";

                if (self.IsVisible) {
                    self.VisualElement.style.visibility = 'visible';
                } else {
                    self.VisualElement.style.visibility = 'none';
                }
            });

        },

        Place: function (container) {
            if (!container) throw "NullReferenceException : container is null";

        }

    });

    YammerCore.ClassObject("DisposableUIElement", {

        Init: function () {
            this.Requires("UIElement");
        },

        Dispose: function () {
            this.Delete();
        }

    });


    YammerCore.ClassObject("SearchResult", {

        Init: function () {


        }

    });


});





if (!Array.prototype.contains) {
    Array.prototype.contains = function (element) { return this.indexOf(element) > -1; };
}

if (!Array.prototype.max) {
    Array.prototype.max = function () { return Math.max.apply(null, this); };
}

if (!String.prototype.trim) {
    String.prototype.trim = function () { return this.replace(/^\s+|\s+$/g, ''); };

    String.prototype.ltrim = function () { return this.replace(/^\s+/, ''); };

    String.prototype.rtrim = function () { return this.replace(/\s+$/, ''); };

    String.prototype.fulltrim = function () { return this.replace(/(?:(?:^|\n)\s+|\s+(?:$|\n))/g, '').replace(/\s+/g, ' '); };
}



// #.Extensions Folder
// @StringExtensions
// 
if (!String.prototype.endsWith) {
    String.prototype.endsWith = function (suffix) {
        return this.indexOf(suffix, this.length - suffix.length) !== -1;
    };
}
if (!String.prototype.startsWith) {
    String.prototype.startsWith = function (str) {
        return this.indexOf(str) == 0;
    };
}

// #.Extensions Folder
// @HtmlElementExtensions
// 
if (!HTMLElement.prototype.removeClass) {
    HTMLElement.prototype.removeClass = function (value) {
        if (this.hasClass(value)) {
            var reg = new RegExp('(\\s|^)' + value + '(\\s|$)');
            this.className = this.className.replace(reg, ' ');
        }
    }
}

if (!HTMLElement.prototype.addClass) {
    HTMLElement.prototype.addClass = function (value) {
        if (!this.hasClass(value)) this.className += " " + value;
    }

}

if (!HTMLElement.prototype.hasClass) {
    HTMLElement.prototype.hasClass = function (value) {
        return this.className.match(new RegExp('(\\s|^)' + value + '(\\s|$)'));
    }
}

function addClass(ele, cls) {
    if (!this.hasClass(ele, cls)) ele.className += " " + cls;
}

function removeClass(ele, cls) {
    if (hasClass(ele, cls)) {
        var reg = new RegExp('(\\s|^)' + cls + '(\\s|$)');
        ele.className = ele.className.replace(reg, ' ');
    }
}

var messageSearchElement = '<div><div class="message-body"><div class="message-image"><img  width="48px" height="48px" /></div><div class="message-container"><div><span class="message-username"></span><span class="message-privacy"></span></div><div><span class="message-recipient"></span></div><div class="message-content"></div></div></div></div><div class="clear"></div>';
var peopleSearchHeader = '<div style="margin:0 0 0 24px;padding:0 12px 0 12px;height:30px;"><div style="float:left">People <span  class="chvrn">&rsaquo;</span></div><div style="float:right"><div style="float:left;width:150px;">Joined On <span  class="chvrn">&rsaquo;</span></div><div style="float:right;width:150px;">Followers  <span class="chvrn">&rsaquo;</span></div></div></div>'
var groupsSearchHeader = '<div style="margin:0 0 0 24px;padding:0 12px 0 12px;height:30px;"><div style="float:left">Groups <span  class="chvrn">&rsaquo;</span></div><div style="float:right;width:150px;">Members  <span class="chvrn">&rsaquo;</span></div></div>'

var peopleSearchElement = '<div><div class="people-body"><div class="people-image"><img width="48px" height="48px" /></div><div class="people-container"><div><span class="people-username"></span></div><div><span class="people-status"></span></div></div><div class="people-meta"><div class="people-joined"><span></span></div><div class="people-followers"><span></span></div></div></div></div><div class="clear"></div>';
var groupsSearchElement = '<div><div class="groups-body"><div class="groups-image"><img width="48px" height="48px" /></div><div class="groups-container"><div><span class="groups-title"></span></div></div><div class="groups-meta"><div class="groups-members"><span></span></div></div></div></div><div class="clear"></div>';